<?php

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}
// Setting the global variables
define('VERIFY_KEY', 'd3vax7JPi2a203ewrqweTDM9yxa904drQX0jAj4G.29434425');
define('LICENSE_SERVER_URL', 'https://goatone.com');
define('ITEM_REFERENCE', 'GOAT One Payment Gateway Plugin');
// Add Custom code for 
$keysection = get_option('goat_license_key');
//$keysection = '';

/*=================================    Activate & deactive Code========================*/
add_action( 'admin_post_goat_license_action', 'goat_license_action' );
 function goat_license_action(){
  $nonce = $_POST['_goat_nonce'];
if ( current_user_can( 'edit_posts' ) ) {
      //if ( current_user_can( 'edit_posts' ) && check_admin_referer( 'goat-license-nonce' ) ) {
      $license_key = $_POST['goat_license_key'];
         // // License data.
         if(!empty($license_key)){
          //activate the license key
            // API query parameters
            $api_params1  = array(
             'slm_action' => 'slm_activate',
             'secret_key' => GOAT_SPECIAL_VERIFY_KEY,
             'license_key' => $license_key,
             'registered_domain' => $_SERVER['SERVER_NAME'],
             'item_reference' => urlencode(ITEM_REFERENCE)
            );
            // Send query to the license manager server
            $query1       = esc_url_raw(add_query_arg($api_params1, LICENSE_SERVER_URL));
            $response1    = wp_remote_get($query1, array(
             'timeout' => 20,
             'sslverify' => false
            ));
            // Check for error in the response
            if (is_wp_error($response1)) {
             //echo '<div class="notice notice-warning"><p>Unexpected Error! The query returned with an error.</p></div>';
              wp_redirect( admin_url( 'admin.php?page=wc-settings&tab=checkout&section=goatone&error=yes') ); 
              exit;
            }
            //var_dump($response);//uncomment it if you want to look at the full response
            // License data.
            $license_data1 = json_decode(wp_remote_retrieve_body($response1));
            
            if ($license_data1->result == 'success') { 
             //Success was returned for the license activation
             //Uncomment the followng line to see the message that returned from the license server
             //echo '<br /><div class="notice notice-success"><p>The following message was returned from the server: ' . $license_data1->message.'</p></div>';
             //Save the license key in the options table
              update_option('goat_license_key', $license_key);
              wp_redirect( admin_url( 'admin.php?page=wc-settings&tab=checkout&section=goatone&success=yes') ); 
              exit;
            } else {
             //Show error to the user. Possibly entered incorrect license key.
             //Uncomment the followng line to see the message that returned from the license server
             //echo '<br /><div class="notice notice-warning"><p>The following message was returned from the server: ' . $license_data1->message.'</p></div>';
              wp_redirect( admin_url( 'admin.php?page=wc-settings&tab=checkout&section=goatone&error=yes') ); 
              exit;
            }
         } else {
          //Show error to the user. Probably entered incorrect license key.
          //Uncomment the followng line to see the message that returned from the license server
          //echo '<br />The following message was returned from the server: ' . $license_data->message;
          wp_redirect( admin_url( 'admin.php?page=wc-settings&tab=checkout&section=goatone&error=yes') ); 
          exit;
         }
        }  
        
      die();
    }
  add_action( 'wp_ajax_goat_license_deactivate', 'goat_license_deactivate' );
  function goat_license_deactivate(){
    if ( current_user_can( 'edit_posts' ) && check_admin_referer( 'goat-deactivate-nonce' ) ) {  
      $license_key = get_option('goat_license_key');
        // API query parameters
        $api_params  = array(
         'slm_action' => 'slm_deactivate',
         'secret_key' => GOAT_SPECIAL_VERIFY_KEY,
         'license_key' => $license_key,
         'registered_domain' => $_SERVER['SERVER_NAME'],
         'item_reference' => urlencode(ITEM_REFERENCE)
        );
        // Send query to the license manager server
        $query       = esc_url_raw(add_query_arg($api_params, LICENSE_SERVER_URL));
        $response    = wp_remote_get($query, array(
         'timeout' => 20,
         'sslverify' => false
        ));

        // Check for error in the response
        if (is_wp_error($response)) {
         //echo '<div class="notice notice-warning"><p>Unexpected Error! The query returned with an error.</p></div>';
          wp_redirect( admin_url( 'admin.php?page=wc-settings&tab=checkout&section=goatone&error=yes') ); 
          exit;
        }
        // License data.
        $license_data = json_decode(wp_remote_retrieve_body($response));
        // Do something with it.
        if ($license_data->result == 'success') { 
         //Success was returned for the license activation
         //Uncomment the followng line to see the message that returned from the license server
         //echo '<br /><div class="notice notice-warning"><p>The following message was returned from the server: ' . $license_data->message.'</p></div>';
         //Remove the license key from the options table. It will need to be activated again. 
          update_option('goat_license_key', '');  
          wp_redirect( admin_url( 'admin.php?page=wc-settings&tab=checkout&section=goatone&deactive=yes') ); 
          exit;
        } else {
         //Show error to the user. Probably entered incorrect license key.
         //echo '<br /><div class="notice notice-warning"><p>The following message was returned from the server: ' . $license_data->message.'</p></div>';
         wp_redirect( admin_url( 'admin.php?page=wc-settings&tab=checkout&section=goatone&error=yes') ); 
          exit;   
        } 
    }
  }


  function check_license_status() {
    $licensekey   = get_option('goat_license_key');
    if(!empty($licensekey)){
      $api_params3 = array(
       'slm_action' => 'slm_check',
       'secret_key' => GOAT_SPECIAL_VERIFY_KEY,
       'license_key' => $licensekey
      );
      // Send query to the license manager server
      $response3   = wp_remote_get(add_query_arg($api_params3, LICENSE_SERVER_URL), array(
       'timeout' => 20,
       'sslverify' => false
      ));
      // Check for error in the response
      if (is_wp_error($response3)) {
       echo "Unexpected Error! The query returned with an error.";
      }
      $license_data3 = json_decode(wp_remote_retrieve_body($response3));
      if($license_data3->result=='error'){
        $status_val = 'inactive';
      }else{
        $status_val = $license_data3->status;
      }      
    } else {
      $status_val = 'inactive';
    }
    return $status_val;
  }